SystemOrganization addCategory: #'Sight-Callgraph'!
SystemOrganization addCategory: #'Sight-Callgraph-Tests'!
SystemOrganization addCategory: #'Sight-Callgraph-Testbed'!

Exception subclass: #SdNonDeterministicBehaviorDetected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdNonDeterministicBehaviorDetected methodsFor: 'priv handling' stamp: 'mt 7/15/2011 13:01:55.166'!
defaultAction

	UnhandledError signalForException: self.! !

AbstractEvent subclass: #SdTraceItEvent
	instanceVariableNames: 'context receiver testClass testSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdTraceItEvent commentStamp: 'mt 7/14/2011 15:35:49.342' prior: 0!
This is a special system event, similar to Do-It, which is used to trace source code or test methods.

If you want to store and re-use it, pay attention to #receiver!!!

!SdTraceItEvent class methodsFor: 'accessing' stamp: 'mt 5/5/2011 10:22:41.014'!
changeKind

	^ #TraceIt! !

!SdTraceItEvent class methodsFor: 'instance creation' stamp: 'mt 7/14/2011 16:03:53.276'!
expression: stringOrStream

	^ self
		expression: stringOrStream
		context: nil
		receiver: nil! !

!SdTraceItEvent class methodsFor: 'instance creation' stamp: 'mt 7/14/2011 15:31:49.672'!
expression: stringOrStream context: aContext

	^ self
		expression: stringOrStream
		context: aContext
		receiver: nil! !

!SdTraceItEvent class methodsFor: 'instance creation' stamp: 'mt 7/14/2011 15:31:11.919'!
expression: stringOrStream context: aContext receiver: anObject

	| instance |
	instance := self item: stringOrStream kind: AbstractEvent expressionKind.
	instance
		context: aContext;
		receiver: anObject.
	^ instance! !

!SdTraceItEvent class methodsFor: 'instance creation' stamp: 'mt 7/14/2011 15:31:35.453'!
expression: stringOrStream receiver: anObject

	^ self
		expression: stringOrStream
		context: nil
		receiver: anObject! !

!SdTraceItEvent class methodsFor: 'accessing' stamp: 'mt 5/23/2011 15:04:54.33'!
supportedKinds

	^ {self expressionKind. #test}! !

!SdTraceItEvent class methodsFor: 'instance creation' stamp: 'mt 2/16/2012 11:11:12.465'!
test: aTestReference

	^ self
		testClass: aTestReference testClass
		selector: aTestReference testSelector! !

!SdTraceItEvent class methodsFor: 'instance creation' stamp: 'mt 5/23/2011 14:43:04.509'!
testClass: aClass selector: aSymbol

	| instance |
	instance := self
		item: aSymbol kind: #test.
	instance
		testClass: aClass;
		testSelector: aSymbol.
	^ instance  ! !

!SdTraceItEvent methodsFor: 'comparing' stamp: 'mt 7/17/2011 20:47:02.374'!
= anEvent

	^ self == anEvent or: [
		self class == anEvent class
			and: [self itemKind == anEvent itemKind]
			and: [self itemExpression == anEvent itemExpression]
			and: [self testClass == anEvent testClass]
			and: [self testSelector == anEvent testSelector]]! !

!SdTraceItEvent methodsFor: 'accessing' stamp: 'mt 5/5/2011 10:27:06.663'!
context

	^ context! !

!SdTraceItEvent methodsFor: 'accessing' stamp: 'mt 5/5/2011 10:27:33.689'!
context: aContext

	context := aContext.! !

!SdTraceItEvent methodsFor: 'evaluating' stamp: 'mt 7/15/2011 13:13:02.484'!
evaluate

	self isTestCall ifTrue: [^ self testClass run: self testSelector].
	self isCodeCall ifTrue: [
		^ Compiler
			evaluate: self itemExpression
			for: self receiver
			logged: false]! !

!SdTraceItEvent methodsFor: 'comparing' stamp: 'mt 7/17/2011 20:51:05.82'!
hash

	^ (((self class hash
		bitXor: self itemKind hash)
		bitXor: self itemExpression hash)
		bitXor: self testClass hash)
		bitXor: self testSelector hash! !

!SdTraceItEvent methodsFor: 'testing' stamp: 'mt 7/14/2011 15:32:46.86'!
isCodeCall

	^ self itemKind == #expression! !

!SdTraceItEvent methodsFor: 'testing' stamp: 'mt 7/14/2011 15:32:38.011'!
isTestCall

	^ self itemKind == #test! !

!SdTraceItEvent methodsFor: 'testing' stamp: 'mt 5/5/2011 10:29:45.211'!
isTraceIt

	^ true! !

!SdTraceItEvent methodsFor: 'printing' stamp: 'mt 5/5/2011 10:30:52.501'!
printEventKindOn: aStream

	aStream nextPutAll: 'TraceIt'.! !

!SdTraceItEvent methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:33:12.407'!
receiver

	^ receiver! !

!SdTraceItEvent methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:33:19.588'!
receiver: anObject

	receiver := anObject.! !

!SdTraceItEvent methodsFor: 'accessing' stamp: 'mt 5/23/2011 14:38:26.306'!
testClass

	^ testClass! !

!SdTraceItEvent methodsFor: 'accessing' stamp: 'mt 5/23/2011 14:38:35.374'!
testClass: aClass

	testClass := aClass.! !

!SdTraceItEvent methodsFor: 'accessing' stamp: 'mt 1/31/2012 18:38:45.351'!
testReference

	^ STestReference class: self testClass selector: self testSelector! !

!SdTraceItEvent methodsFor: 'accessing' stamp: 'mt 5/23/2011 14:39:09.8'!
testSelector

	^ testSelector! !

!SdTraceItEvent methodsFor: 'accessing' stamp: 'mt 5/23/2011 14:39:16.076'!
testSelector: aSymbol

	testSelector := aSymbol.! !

MwMethodWrapper subclass: #SdCallWrapper
	instanceVariableNames: 'ids tracer callsBefore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdCallWrapper class methodsFor: 'instance creation' stamp: 'mp 1/25/2010 14:25'!
on: aSymbol inClass: aClass withTracer: aTracer

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper ifNotNil: [wrapper tracer: aTracer].
	^ wrapper! !

!SdCallWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 16:34:47.59'!
afterMethod: anObject with: arguments result: returnValue

	self tracer returnFromNode: self ids removeLast.! !

!SdCallWrapper methodsFor: 'evaluating' stamp: 'mt 7/14/2011 12:14:58.75'!
beforeMethod: anObject with: arguments

	self ids add: (self tracer 
				nextCallNodeOn: self wrappedClass 
				with: self clientSelector
				receiverObject: anObject
				arguments: arguments
				callsBefore: self callsBefore).! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 6/15/2010 16:08'!
callsBefore
	"Answer the value of callsBefore"

	^ callsBefore! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 6/15/2010 16:08'!
callsBefore: anObject
	"Set the value of callsBefore"

	callsBefore := anObject! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:09'!
ids
	"Answer the value of ids"

	^ ids! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:09'!
ids: anObject
	"Set the value of ids"

	ids := anObject! !

!SdCallWrapper methodsFor: 'initialization' stamp: 'mp 6/15/2010 16:09'!
initialize

	self ids: OrderedCollection new.
	self callsBefore: 0.! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 14:24'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!SdCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 14:24'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

!SdCallWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 16:34:35.564'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| returnValue |

	self beforeMethod: anObject with: anArrayOfObjects.

	self callsBefore: self callsBefore + 1.
	returnValue := super valueWithReceiver: anObject arguments: anArrayOfObjects.

	self afterMethod: anObject with: anArrayOfObjects result: returnValue.

	^ returnValue! !

SdCallWrapper subclass: #SdGlobalPropertyWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdGlobalPropertyWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 17:14:40.683'!
afterMethod: anObject with: arguments result: returnValue

	"Collect the properties."
	self tracer
		collectGlobalPropertiesAfterReceiver: anObject
		arguments: arguments
		returnValue: returnValue.
		
	super afterMethod: anObject with: arguments result: returnValue.! !

!SdGlobalPropertyWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 17:06:25.27'!
beforeMethod: anObject with: arguments

	"Let the tracer select the correct node."
	super beforeMethod: anObject with: arguments.
	
	"Collect the properties."
	self tracer
		collectGlobalPropertiesBeforeReceiver: anObject
		arguments: arguments.! !

SdCallWrapper subclass: #SdProfilingWrapper
	instanceVariableNames: 'stopwatchs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdProfilingWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 16:35:00.229'!
afterMethod: anObject with: arguments result: returnValue

	self tracer
		addProfileInformation: ((self stopwatchs removeLast)
			suspend;
			duration)
		node: self ids last.

	super afterMethod: anObject with: arguments result: returnValue.! !

!SdProfilingWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 16:28:53.576'!
beforeMethod: anObject with: arguments

	super beforeMethod: anObject with: arguments.
	(self stopwatchs add: Stopwatch new) activate.! !

!SdProfilingWrapper methodsFor: 'initialization' stamp: 'mt 7/14/2011 12:10:49.795'!
initialize

	super initialize.
	stopwatchs := OrderedCollection new.! !

!SdProfilingWrapper methodsFor: 'accessing' stamp: 'mp 1/26/2010 09:28'!
stopwatchs
	"Answer the value of stopwatchs"

	^ stopwatchs! !

MwMethodWrapper subclass: #SdNonDeterministicBehaviorNotifier
	instanceVariableNames: 'tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdNonDeterministicBehaviorNotifier commentStamp: 'mt 7/15/2011 13:23:55.672' prior: 0!
Install this wrapper on methods that cause random behavior.!

!SdNonDeterministicBehaviorNotifier class methodsFor: 'instance creation' stamp: 'mt 7/15/2011 13:29:41.506'!
on: aSymbol inClass: aClass withTracer: aTracer

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper ifNotNil: [wrapper tracer: aTracer].
	^ wrapper! !

!SdNonDeterministicBehaviorNotifier methodsFor: 'accessing' stamp: 'mt 7/15/2011 13:28:35.156'!
tracer

	^ tracer! !

!SdNonDeterministicBehaviorNotifier methodsFor: 'accessing' stamp: 'mt 7/15/2011 13:28:40.25'!
tracer: aTracer

	tracer := aTracer.! !

!SdNonDeterministicBehaviorNotifier methodsFor: 'evaluating' stamp: 'mt 7/15/2011 13:29:22.618'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	self tracer callgraph isNonDeterministic: true.
	^ super valueWithReceiver: anObject arguments: anArrayOfObjects! !

MwMethodWrapper subclass: #SdSpecificWrapper
	instanceVariableNames: 'numberOfCallsBefore tracer node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

SdSpecificWrapper subclass: #SdByteCodeCoverageWrapper
	instanceVariableNames: 'coveredByteCodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdByteCodeCoverageWrapper methodsFor: 'accessing' stamp: 'mp 11/8/2010 15:21:28.79'!
coveredByteCodes
	"Answer the value of coveredByteCodes"

	^ coveredByteCodes ifNil: [coveredByteCodes := OrderedCollection new]! !

!SdByteCodeCoverageWrapper methodsFor: 'accessing' stamp: 'mp 11/8/2010 15:19:07.504'!
coveredByteCodes: anObject
	"Set the value of coveredByteCodes"

	coveredByteCodes := anObject! !

!SdByteCodeCoverageWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 10:03:04.545'!
data

	^ self coveredByteCodes! !

!SdByteCodeCoverageWrapper methodsFor: 'evaluating' stamp: 'mp 11/8/2010 15:54:55.976'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| result |
	self isSpecificCall 
		ifTrue: [self decrementCallCount.
				result := thisContext
							runSimulatedMethodOnly: [self clientMethod 
															valueWithReceiver: anObject 
															arguments: anArrayOfObjects]
							contextAtEachStep: [ :ctx | 
								self compiledMethod == ctx method
									ifTrue: [	self coveredByteCodes add: ctx pc]]]
		ifFalse: [self decrementCallCount.
				result := self clientMethod 
								valueWithReceiver: anObject 
								arguments: anArrayOfObjects].
	^ result! !

SdSpecificWrapper subclass: #SdDebugWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdDebugWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 10:15:20.289'!
beforeMethod

	self numberOfCallsBefore = 1
		ifTrue: [BreakpointManager
			installInClass: self wrappedClass
			selector: self clientSelector].
	self decrementCallCount.! !

!SdDebugWrapper methodsFor: 'installation' stamp: 'mt 7/15/2011 10:14:56.169'!
uninstall

	BreakpointManager unInstall: self wrappedClass >> self clientSelector.
	super uninstall.! !

SdSpecificWrapper subclass: #SdSpecificPropertyWrapper
	instanceVariableNames: 'found'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdSpecificPropertyWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:48'!
found
	"Answer the value of found"

	^ found ifNil: [found := false]! !

!SdSpecificPropertyWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:48'!
found: anObject
	"Set the value of found"

	found := anObject! !

!SdSpecificPropertyWrapper methodsFor: 'evaluating' stamp: 'mt 7/15/2011 15:14:35.001'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| result |
	self isSpecificCall ifTrue: [
		self found: true.
		self tracer
			collectPropertiesBeforeNode: self node
			receiver: anObject
			arguments: anArrayOfObjects].
	
	self decrementCallCount.
	
	result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	
	self found ifTrue: [
		self incrementCallCount.

		self tracer
			collectPropertiesAfterNode: self node
			receiver: anObject
			arguments: anArrayOfObjects 
			returnValue: result.

		self isSpecificCall ifTrue: [
			self
				found: false;
				decrementCallCount]].
		
	^ result
! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 10:03:14.668'!
data
	"Return the collected data of this specific wrapper."

	^ nil! !

!SdSpecificWrapper methodsFor: 'count' stamp: 'mp 1/25/2010 16:39'!
decrementCallCount
	
	self numberOfCallsBefore: self numberOfCallsBefore - 1.! !

!SdSpecificWrapper methodsFor: 'count' stamp: 'mp 1/25/2010 19:07'!
incrementCallCount
	
	self numberOfCallsBefore: self numberOfCallsBefore + 1.! !

!SdSpecificWrapper methodsFor: 'count' stamp: 'mp 1/25/2010 16:40'!
isSpecificCall
	
	^ self numberOfCallsBefore = 0! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 15:13:09.364'!
node

	^ node! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 15:13:14.683'!
node: aNode

	node := aNode.! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 16:39'!
numberOfCallsBefore
	"Answer the value of numberOfCallsBefore"

	^ numberOfCallsBefore! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 16:39'!
numberOfCallsBefore: anObject
	"Set the value of numberOfCallsBefore"

	numberOfCallsBefore := anObject! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 14:25:08.484'!
tracer

	^ tracer! !

!SdSpecificWrapper methodsFor: 'accessing' stamp: 'mt 7/15/2011 14:25:13.846'!
tracer: aTracer

	tracer := aTracer.! !

Object subclass: #SdCallgraphNode
	instanceVariableNames: 'id parent children properties requestedProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdCallgraphNode commentStamp: 'mt 3/4/2011 10:33:24.411' prior: 0!
Represents a node in a call graph. Such a node can have a parent (if not the root) node, child nodes, and several information stored.!

SdCallgraphNode subclass: #SdCallgraph
	instanceVariableNames: 'traceEvent isNonDeterministic selectedCategories cachedQueries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdCallgraph commentStamp: 'mt 7/15/2011 12:47:35.871' prior: 0!
This is a database that stores relevant information about a specific call graph (or call tree) resulting from a test method or arbitrary Smalltalk code execution.

Additionally this is the root of the call tree.

Once a call graph was identified as being non-deterministic, it cannot and must not #run again as no more data can be collected in a consistent way.!

!SdCallgraph methodsFor: 'collection api' stamp: 'mt 9/1/2011 13:41:44.664'!
anySatisfy: aBlock
	
	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!SdCallgraph methodsFor: 'collection api' stamp: 'mt 7/14/2011 16:34:47.583'!
at: aNumber

	^ self findNodeInSubGraph: aNumber startNode: self! !

!SdCallgraph methodsFor: 'queries' stamp: 'mt 7/19/2011 16:16:36.734'!
cachedQueries

	^ cachedQueries ifNil: [cachedQueries := Dictionary new]! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/18/2011 15:07:12.563'!
callgraph

	^ self! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 2/16/2012 11:36:54.884'!
clientMethod

	^ self traceEvent isTestCall
		ifTrue: [self traceEvent testReference compiledMethod]
		ifFalse: [super clientMethod]! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 2/16/2012 11:28:28.227'!
clientReference

	^ self traceEvent isTestCall
		ifTrue: [self traceEvent testReference methodReference]
		ifFalse: [super clientReference]! !

!SdCallgraph methodsFor: 'collection api' stamp: 'tfel 5/17/2011 10:46:28.593'!
detect: aBlock

	^ self
		detect: aBlock
		ifNone: [self error: 'Object is not in the collection.']! !

!SdCallgraph methodsFor: 'collection api' stamp: 'mt 7/14/2011 17:09:03.511'!
detect: aBlock ifNone: exceptionBlock

	self do: [:node | (aBlock value: node) ifTrue: [^ node]].
	^ exceptionBlock value! !

!SdCallgraph methodsFor: 'collection api' stamp: 'mt 7/14/2011 16:57:26.113'!
do: aBlock
	
	self traverseCallGraph: self with: [:aNode | aBlock value: aNode].
! !

!SdCallgraph methodsFor: 'queries' stamp: 'mt 7/16/2011 16:23:38.095'!
find: aSelector callOn: aClass number: receiverId

	^ self detect: [:n |
		n receiverId = receiverId
			and: [n clientClass = aClass or: [n receiverClass = aClass]]
			and: [n clientSelector = aSelector]]! !

!SdCallgraph methodsFor: 'queries' stamp: 'mt 7/16/2011 16:24:01.544'!
findAll: aSelector callsOn: aClass number: receiverId

	^ self select: [:n |
		n receiverId = receiverId
			and: [n clientClass = aClass or: [n receiverClass = aClass]]
			and: [n clientSelector = aSelector]]! !

!SdCallgraph methodsFor: 'enumeration' stamp: 'mt 7/14/2011 15:03:48.859'!
findNodeInSubGraph: aNumber startNode: aNode

	| lastNode |
	aNode children do: [:each | 
		each id = aNumber ifTrue: [^ each].
		each id < aNumber ifTrue: [lastNode := each].
		each id > aNumber ifTrue: [
			lastNode	ifNotNil: [^ self findNodeInSubGraph: aNumber startNode: lastNode]]].
	lastNode ifNotNil: [^ self findNodeInSubGraph: aNumber startNode: lastNode].
	^ nil! !

!SdCallgraph methodsFor: 'initialization' stamp: 'mt 7/14/2011 17:05:39.99'!
initialize 

	super initialize.	
	id := self rootId.! !

!SdCallgraph methodsFor: 'queries' stamp: 'tfel 5/17/2011 10:55:54.696'!
instantiationOfObjectWithId: anObjectId

	^ self
		detect: [ :node | 
			(node clientSelector = #basicNew) and: [node returnId = anObjectId]]
		ifNone: [ nil ]
! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/15/2011 12:46:33.36'!
isNonDeterministic

	^ isNonDeterministic ifNil: [isNonDeterministic := false]! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/15/2011 12:46:48.121'!
isNonDeterministic: aBoolean

	isNonDeterministic := aBoolean.! !

!SdCallgraph methodsFor: 'id handling' stamp: 'mt 7/14/2011 15:58:44.205'!
nextId: currentId
	"Calculate the next id based on the given id."
	
	^ currentId + 1! !

!SdCallgraph methodsFor: 'queries' stamp: 'mt 7/19/2011 16:16:49.212'!
resetCachedQueries

	cachedQueries := nil.! !

!SdCallgraph methodsFor: 'id handling' stamp: 'mt 7/14/2011 15:57:29.4'!
rootId

	^ 0! !

!SdCallgraph methodsFor: 'running' stamp: 'mt 7/17/2011 21:24:47.942'!
run

	self isNonDeterministic ifTrue: [^ nil].
	self traceEvent ifNotNil: [:event | ^ event evaluate].
	^ nil! !

!SdCallgraph methodsFor: 'collection api' stamp: 'mt 7/16/2011 16:11:10.447'!
select: aBlock
	
	| result |
	result := OrderedCollection new.
	self do: [:node | (aBlock value: node) ifTrue: [result add: node]].
	^ result! !

!SdCallgraph methodsFor: 'queries' stamp: 'mt 7/19/2011 16:16:53.896'!
selectMethodCalls: aMethodReference

	^ (self cachedQueries at: #methodCalls ifAbsentPut: [Dictionary new])
		at: aMethodReference
		ifAbsentPut: [self select: [:node | node clientReference = aMethodReference]]! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/15/2011 17:52:48.492'!
selectedCategories

	^ selectedCategories ifNil: [#()]! !

!SdCallgraph methodsFor: 'accessing' stamp: 'abc 8/12/2011 21:01:28.56'!
selectedCategories: someSystemCategories

	selectedCategories := someSystemCategories asSet asArray. "remove duplicates"! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:27:19.301'!
traceEvent
	"Return the overall context that caused this call tree."
	
	^ traceEvent! !

!SdCallgraph methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:27:30.674'!
traceEvent: aTraceEvent
	
	traceEvent := aTraceEvent.! !

!SdCallgraph methodsFor: 'enumeration' stamp: 'mt 7/14/2011 15:03:28.869'!
traverseCallGraph: aNode with: aBlock
	"Prefix Order"
	aNode children do: [:each | 
		aBlock value: each.
		self traverseCallGraph: each with: aBlock].! !

!SdCallgraph methodsFor: 'enumeration' stamp: 'mt 7/14/2011 15:03:21.755'!
traverseCallGraph: aNode with: aBlock abort: anotherBlock
	"Prefix Order"
	aNode children do: [:each | 
		aBlock value: each.
		(anotherBlock value: each) 
			ifFalse: [self traverseCallGraph: each with: aBlock abort: anotherBlock]].! !

!SdCallgraphNode methodsFor: 'comparing' stamp: 'mt 7/15/2011 11:49:01.516'!
= aNode

	^ (aNode isKindOf: SdCallgraphNode)
		and: [self id == aNode id]
		and: [self children size = aNode children size]
		and: [self children withIndexDo: [:node :index |
			node = (aNode children at: index) ifFalse: [^ false]].
			true]! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/18/2011 15:07:00.391'!
callgraph

	^ self parent ifNotNil: [:node | node callgraph]! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:02:18.004'!
children

	^ children! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:58:36.949'!
clientClass

	^ nil! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 2/16/2012 11:35:31.6'!
clientMethod

	self subclassResponsibility.! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:53:52.946'!
clientReference

	^ MethodReference new! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:58:42.407'!
clientSelector

	^ nil! !

!SdCallgraphNode methodsFor: 'comparing' stamp: 'mt 7/15/2011 11:48:23.935'!
hash

	^ (super hash bitXor: self id hash)
		bitXor: self children hash! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:48.858'!
id

	^ id! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:45.107'!
id: anObject

	id := anObject.! !

!SdCallgraphNode methodsFor: 'testing' stamp: 'mt 2/16/2012 11:13:16.762'!
ifEmpty: aBlock

	self isEmpty ifTrue: [^ aBlock value].! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:03:48.551'!
includesProperty: aSymbol 

	^ properties includesKey: aSymbol! !

!SdCallgraphNode methodsFor: 'initialization' stamp: 'mt 7/15/2011 14:51:40.153'!
initialize

	super initialize.
	
	children := OrderedCollection new.
	properties := Dictionary new.
	requestedProperties := OrderedCollection new.! !

!SdCallgraphNode methodsFor: 'testing' stamp: 'mt 7/15/2011 11:15:32.532'!
isEmpty

	^ self children isEmpty! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:02:10.033'!
parent

	^ parent! !

!SdCallgraphNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 15:19:41.211'!
parent: aNode

	parent := aNode.! !

!SdCallgraphNode methodsFor: 'printing' stamp: 'mt 7/15/2011 11:21:57.93'!
printString

	^ 'Node<{1}>' format: {self id}! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:07:57.788'!
properties

	^ properties keys! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:03:55.856'!
removeProperty: aSymbol 

	properties ifNil: [^ self].
	properties removeKey: aSymbol ifAbsent: [].! !

!SdCallgraphNode methodsFor: 'properties - future' stamp: 'mt 7/18/2011 14:04:09.774'!
requestProperty: aSymbol 

	(aSymbol includesSubString: #Id)
		ifTrue: [Error signal: 'You cannot collect object ids with specific runs!!'].
		
	requestedProperties add: aSymbol.! !

!SdCallgraphNode methodsFor: 'properties - future' stamp: 'mt 7/15/2011 14:56:05.095'!
requestedPropertiesSatisfying: aBlock

	[^ requestedProperties select: aBlock]
		ensure: [requestedProperties removeAllSuchThat: aBlock].! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:04:05.421'!
setProperty: aSymbol toValue: anObject 

	anObject ifNil: [^ self removeProperty: aSymbol].
	properties at: aSymbol put: anObject.! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:04:10.992'!
valueOfProperty: aSymbol 

	^ self
		valueOfProperty: aSymbol
		ifAbsent: []! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:04:18.437'!
valueOfProperty: aSymbol ifAbsent: aBlock

	^ properties
		at: aSymbol
		ifAbsent: aBlock! !

!SdCallgraphNode methodsFor: 'properties' stamp: 'mt 7/13/2011 22:41:59.618'!
valueOfProperty: aSymbol ifAbsentPut: aBlock

	^ properties
		at: aSymbol
		ifAbsentPut: aBlock! !

SdCallgraphNode subclass: #SdMethodCallNode
	instanceVariableNames: 'callsBefore clientClass clientSelector receiverClass receiverId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdMethodCallNode commentStamp: 'mt 7/16/2011 14:39:20.743' prior: 0!
A node in a callgraph that represents a method call. Important information is cached as instance variables and meant to be updated on the first run when the callgraph is created.

Additional properties need to be filled afterwards and are stored in the properties dictionary.!

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:51:03.439'!
argumentClasses

	^ self valueOfProperty: #argumentClasses! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:51:13.407'!
argumentIds

	^ self valueOfProperty: #argumentIds! !

!SdMethodCallNode methodsFor: 'parsing' stamp: 'mt 7/18/2011 11:47:51.914'!
argumentNames

	^ Parser new parseParameterNames: self clientSource! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:50:15.303'!
argumentObjectsAfter

	^ self valueOfProperty: #argumentObjectsAfter! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:51:08.394'!
argumentObjectsBefore

	^ self valueOfProperty: #argumentObjectsBefore! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 17:20:27.549'!
callsBefore
	"Number of calls of this method that occured before this call in the current context."

	^ callsBefore! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 17:20:43.316'!
callsBefore: anInteger

	callsBefore := anInteger.! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:23.265'!
clientClass
	"Return the class that actually implements #clientSelector."

	^ clientClass! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:25.381'!
clientClass: aClassOrMetaClass

	clientClass := aClassOrMetaClass.! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'TM 5/17/2011 11:06:18.583'!
clientMethod

	^ self clientClass >> self clientSelector! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 17:22:42.872'!
clientReference

	^ MethodReference class: self clientClass selector: self clientSelector! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:27.505'!
clientSelector
	"Return the selector that was called in this node. The method is implemented in #clientClass."

	^ clientSelector! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:29.336'!
clientSelector: anObject
	clientSelector := anObject! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/18/2011 11:47:41.917'!
clientSource

	^ self clientMethod getSource asString! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 16:10:03.538'!
globalArgumentIds

	((self includesProperty: #argumentClasses) and: [
		self includesProperty: #argumentIds]) ifFalse: [^ #()].

	^ self argumentClasses withIndexCollect: [:cls :idx |
		cls -> (self argumentIds at: idx)]! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 15:50:11.935'!
globalReceiverId

	^ self receiverClass -> self receiverId! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 16:10:10.478'!
globalReceiverInstVarIdsAfter

	((self includesProperty: #receiverInstVarClassesAfter) and: [
		self includesProperty: #receiverInstVarIdsAfter]) ifFalse: [^ #()].
	
	^ self receiverInstVarClassesAfter withIndexCollect: [:cls :idx |
		cls -> (self receiverInstVarIdsAfter at: idx)]! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 16:10:14.464'!
globalReceiverInstVarIdsBefore

	((self includesProperty: #receiverInstVarClassesBefore) and: [
		self includesProperty: #receiverInstVarIdsBefore]) ifFalse: [^ #()].

	^ self receiverInstVarClassesBefore withIndexCollect: [:cls :idx |
		cls -> (self receiverInstVarIdsBefore at: idx)]! !

!SdMethodCallNode methodsFor: 'properties - global ids' stamp: 'mt 7/16/2011 16:04:06.007'!
globalReturnId

	((self includesProperty: #returnClass) and: [
		self includesProperty: #returnId]) ifFalse: [^ nil].

	^ self returnClass -> self returnId! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/16/2011 16:46:55.438'!
isInContextWith: aNode
	
	| targetId |
	targetId := aNode globalReceiverId.
	
	^ targetId = self globalReceiverId
		or: [targetId = self globalReturnId]
		or: [self globalReceiverInstVarIdsBefore includes: targetId]
		or: [self globalReceiverInstVarIdsAfter includes: targetId]
		or: [self globalArgumentIds includes: targetId]! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/31/2011 15:35:52.577'!
isInstantiation

	^ self clientSelector == #basicNew! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/31/2011 15:36:07.368'!
isInstantiationOf: aNodeOrClass

	self isInstantiation ifFalse: [^ false].
	^ aNodeOrClass isBehavior
		ifTrue: [self receiverClass theNonMetaClass = aNodeOrClass]
		ifFalse: [self globalReturnId = aNodeOrClass globalReceiverId]! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/16/2011 16:40:22.568'!
isReadOf: aNode

	^ (self isSameObjectAs: aNode) and: [
		(1 to: aNode clientClass instSize) anySatisfy: [:idx |
			self clientMethod readsField: idx]].! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/16/2011 16:38:35.095'!
isSameObjectAs: aNode

	^ self globalReceiverId = aNode globalReceiverId! !

!SdMethodCallNode methodsFor: 'testing' stamp: 'mt 7/31/2011 14:20:35.005'!
isWriteTo: aNode

	^ (self isSameObjectAs: aNode) and: [
		(1 to: aNode clientClass instSize) anySatisfy: [:idx |
			self clientMethod writesField: idx]].! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 1/27/2012 09:59:06.49'!
receiverClass
	"Return the class of the object that received the message. This class does not have to have the #clientSelector implemented."
	
	^ receiverClass! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/14/2011 16:19:34.41'!
receiverClass: aClassOrMetaClass

	receiverClass := aClassOrMetaClass.! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/15/2011 15:53:16.024'!
receiverId
	"Return a number which identifies the receiver object in the space of all objects of the same type, i.e. receiver class. This means that the id can be the same if the #receiverClass is different."
	
	^ receiverId! !

!SdMethodCallNode methodsFor: 'accessing' stamp: 'mt 7/15/2011 15:51:12.618'!
receiverId: anInteger

	receiverId := anInteger.! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 15:47:01.515'!
receiverInstVarClassesAfter

	^ self valueOfProperty: #receiverInstVarClassesAfter! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 15:47:07.663'!
receiverInstVarClassesBefore

	^ self valueOfProperty: #receiverInstVarClassesBefore! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 15:46:54.993'!
receiverInstVarIdsAfter

	^ self valueOfProperty: #receiverInstVarIdsAfter! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 15:46:49.142'!
receiverInstVarIdsBefore

	^ self valueOfProperty: #receiverInstVarIdsBefore! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:50:09.317'!
receiverObjectAfter

	^ self valueOfProperty: #receiverObjectAfter! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:50:58.004'!
receiverObjectBefore

	^ self valueOfProperty: #receiverObjectBefore! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:49:50.582'!
returnClass

	^ self valueOfProperty: #returnClass! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:37:11.216'!
returnId

	^ self valueOfProperty: #returnId! !

!SdMethodCallNode methodsFor: 'properties' stamp: 'mt 7/16/2011 14:49:58.297'!
returnObject

	^ self valueOfProperty: #returnObject! !

Object subclass: #SdCallgraphTracer
	instanceVariableNames: 'currentId currentNode classDictionary callgraph isFirstRun tracingMode requestedGlobalProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph'!

!SdCallgraphTracer commentStamp: 'mt 7/15/2011 17:46:43.97' prior: 0!
Collects call tree information. If you do not set #selectedCategories, an auto-detection will happen.

| cgt |
cgt := SdCallgraphTracer new.

"Convenient tracing of source code. Automatic scope detection."
cgt traceSourceCode: 'MarbleMania new'.
cgt callgraph explore.

"Add information to all nodes."
cgt collectGlobalProperties: #(returnClass returnId).
cgt callgraph explore.

"Add profiling information."
cgt profile: #durationPercent.
cgt callgraph explore.

"Visualize it."
(UiTreeView new
	model: (SdCallgraphModel new
		threshold: 0;
		root: cgt callgraph)) openInWorld.
		
"Add information for a specific node. Much faster than collecting for the whole tree."
cgt collectProperties: #(argumentObjects) inNode: aNode.!

!SdCallgraphTracer methodsFor: 'profiling - callbacks' stamp: 'mt 7/15/2011 16:49:14.38'!
addProfileInformation: aValue node: anId

	(self getNode: anId)
		setProperty: self tracingMode
		toValue: aValue.! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:04:43.177'!
argumentClasses: dict

	(dict at: #node)
		setProperty: #argumentClasses
		toValue: ((dict at: #arguments) collect: [:arg | arg class]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/18/2011 14:09:08.539'!
argumentIds: dict

	((dict at: #node) includesProperty: #argumentClasses)
		ifFalse: [self argumentClasses: dict].

	(dict at: #node)
		setProperty: #argumentIds
		toValue: ((dict at: #arguments) collect: [:arg | self objectIdFor: arg]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/18/2011 14:08:54.781'!
argumentObjectsAfter: dict

	((dict at: #node) includesProperty: #argumentClasses)
		ifFalse: [self argumentClasses: dict].

	(dict at: #node)
		setProperty: #argumentObjectsAfter
		toValue: ((dict at: #arguments) collect: [:arg | arg veryDeepCopy]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/18/2011 14:09:01.207'!
argumentObjectsBefore: dict

	((dict at: #node) includesProperty: #argumentClasses)
		ifFalse: [self argumentClasses: dict].

	(dict at: #node)
		setProperty: #argumentObjectsBefore
		toValue: ((dict at: #arguments) collect: [:arg | arg veryDeepCopy]).! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 9/1/2011 13:28:40.156'!
autoSelectCategories
	"Use the current callgraph to select the categories for tracing."
	
	(self callgraph traceEvent itemKind == #test)
		ifTrue: [self callgraph selectedCategories: (PackageOrganizer default
			packageOfClass: self callgraph traceEvent testClass) systemCategories.
			^ self].
	
	"Just make a test run and use the result. Maybe a too simple approach..."
	self callgraph run ifNotNil: [:result | | pkg |
		pkg := PackageOrganizer default packageOfClass: result class.
		(#(Kernel Collections Graphics Balloon Morphic Network Compiler System) includes: pkg name)
			ifTrue: [^ self].
		self callgraph selectedCategories: pkg systemCategories].! !

!SdCallgraphTracer methodsFor: 'OBSOLETE' stamp: 'mt 7/15/2011 10:10:54.145'!
byteCodeCoverageAt: aCallNode

	| wrapper |
	wrapper := SdByteCodeCoverageWrapper 
		on: aCallNode clientSelector 
		inClass: aCallNode clientClass 
		waitingCalls: aCallNode callsBefore.
			
	self trace: {wrapper}.
	^ wrapper data
! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/14/2011 15:46:00.123'!
callgraph

	^ callgraph ifNil: [callgraph := SdCallgraph new]! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/14/2011 15:45:27.939'!
callgraph: aCallgraph

	callgraph := aCallgraph.! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'TM 5/23/2011 15:48:43.131'!
classDictionary
	"Answer the value of classDictionary"

	^ classDictionary ifNil: [classDictionary := Dictionary new]! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'TM 5/23/2011 15:45:45.955'!
classDictionary: anObject
	"Set the value of classDictionary"

	classDictionary := anObject! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/15/2011 16:57:58.088'!
collectGlobalProperties: someProperties
	"Collect properties for all nodes."
	
	someProperties ifNil: [^ self].
	
	requestedGlobalProperties := someProperties.
	self tracingMode: #property.
	self trace.
	requestedGlobalProperties := nil.! !

!SdCallgraphTracer methodsFor: 'properties - callbacks' stamp: 'mt 7/15/2011 16:54:06.898'!
collectGlobalPropertiesAfterReceiver: receiver arguments: arguments returnValue: result

	(requestedGlobalProperties select: [:symbol |
		self knownPropertiesAfterCall includes: symbol]) do: [:property |
			self
				perform: (property, #:) asSymbol
				with: (Dictionary newFrom: {
					#node -> self currentNode.
					#receiver -> receiver.
					#arguments -> arguments.
					#result -> result})].! !

!SdCallgraphTracer methodsFor: 'properties - callbacks' stamp: 'mt 7/15/2011 16:54:56.395'!
collectGlobalPropertiesBeforeReceiver: receiver arguments: arguments

	(requestedGlobalProperties select: [:symbol |
		self knownPropertiesBeforeCall includes: symbol]) do: [:property |
			self
				perform: (property, #:) asSymbol
				with: (Dictionary newFrom: {
					#node -> self currentNode.
					#receiver -> receiver.
					#arguments -> arguments})].! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/15/2011 17:28:02.088'!
collectProperties: someProperties inNode: aCallNode
	"For convenience."

	self
		collectProperties: someProperties
		inNodes: {aCallNode}.! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/15/2011 17:32:25.347'!
collectProperties: someProperties inNodes: someCallNodes
	"For convenience."

	someCallNodes do: [:node | someProperties do: [:prop |
			node requestProperty: prop]].
	self collectPropertiesInNodes: someCallNodes.! !

!SdCallgraphTracer methodsFor: 'properties - callbacks' stamp: 'mt 7/15/2011 15:01:20.988'!
collectPropertiesAfterNode: node receiver: receiver arguments: arguments returnValue: result

	(node requestedPropertiesSatisfying: [:symbol |
		self knownPropertiesAfterCall includes: symbol]) do: [:property |
			self
				perform: (property, #:) asSymbol
				with: (Dictionary newFrom: {
					#node -> node.
					#receiver -> receiver.
					#arguments -> arguments.
					#result -> result})].! !

!SdCallgraphTracer methodsFor: 'properties - callbacks' stamp: 'mt 7/15/2011 15:00:23.999'!
collectPropertiesBeforeNode: node receiver: receiver arguments: arguments

	(node requestedPropertiesSatisfying: [:symbol |
		self knownPropertiesBeforeCall includes: symbol]) do: [:property |
			self
				perform: (property, #:) asSymbol
				with: (Dictionary newFrom: {
					#node -> node.
					#receiver -> receiver.
					#arguments -> arguments})].! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/15/2011 17:26:44.611'!
collectPropertiesInNode: aCallNode
	
	self collectPropertiesInNodes: {aCallNode}.! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/19/2011 16:22:39.396'!
collectPropertiesInNodes: someCallNodes
	"Use the requested properties in the given nodes and collects them. See SdCallgraphNode>>#requestedProperties."
	
	someCallNodes ifEmpty: [^ self].
	
	self trace: ((someCallNodes collect: [:callNode |
		(SdSpecificPropertyWrapper on: callNode clientSelector inClass: callNode clientClass)
		ifNotNil: [:wrapper |
			wrapper
				numberOfCallsBefore: callNode callsBefore;
				tracer: self;
				node: callNode]]) reject: [:wrapper | wrapper isNil]).
		! !

!SdCallgraphTracer methodsFor: 'properties - convenience' stamp: 'mt 7/16/2011 16:01:19.092'!
collectShallowArguments

	self collectGlobalProperties: #(argumentClasses argumentIds).! !

!SdCallgraphTracer methodsFor: 'properties - convenience' stamp: 'mt 7/16/2011 16:13:12.465'!
collectShallowContext
	"A complete shallow context of a method call. Includes references to arguments, return object, isntance variables and the type and id of the receiver."

	self collectGlobalProperties: #(receiverInstVarClassesBefore receiverInstVarIdsBefore receiverInstVarClassesAfter receiverInstVarIdsAfter returnClass returnId argumentClasses argumentIds).! !

!SdCallgraphTracer methodsFor: 'properties - convenience' stamp: 'abc 8/18/2011 14:24:41.081'!
collectShallowReceiver
	"#receiverClass and #receiverId are collected by default. Only shallow scope of object is needed, which means references on objects held by instance variables."

	self collectGlobalProperties: #(receiverId receiverInstVarClassesBefore receiverInstVarIdsBefore receiverInstVarClassesAfter receiverInstVarIdsAfter).! !

!SdCallgraphTracer methodsFor: 'properties - convenience' stamp: 'mt 7/16/2011 16:05:39.376'!
collectShallowReturn

	self collectGlobalProperties: #(returnClass returnId).! !

!SdCallgraphTracer methodsFor: 'tracing - wrappers' stamp: 'mt 9/1/2011 11:13:53.608'!
createWrappers
	"Create new wrappers for all selected classes and some special cases. Does not actually install the wrappers. Do this with #installWrappers: then."
	
	| wrappers |
	wrappers := OrderedCollection new.

	self selectedClasses do: [:cls |
		"Special wrappers"
		"wrappers add: (self wrapperClass on: #basicNew inClass: cls class withTracer: self)."
	
		"Instance-side wrappers."
		cls selectors do: [:selector | 
			wrappers add: (self wrapperClass on: selector inClass: cls withTracer: self)].		
		"Class-side wrappers."
		cls class selectors do: [:selector | 
			wrappers add: (self wrapperClass on: selector inClass: cls class withTracer: self)]].
	
	"Detect non-deterministic behavior."
	wrappers add: (SdNonDeterministicBehaviorNotifier on: #next inClass: Random withTracer: self).

	^ wrappers reject: [:wrapper | wrapper isNil]
	! !

!SdCallgraphTracer methodsFor: 'tracing - wrappers' stamp: 'mt 2/7/2012 13:31:24.816'!
createWrappersOptimized
	"Needs Sight-Coverage to be installed."
	
	| wrappers |
	wrappers := OrderedCollection new.

	self flag: #fix. "Trace test methods too?"
	self callgraph traceEvent testReference coveredMethods do: [:method |
		wrappers add: (self wrapperClass on: method selector inClass: method methodClass withTracer: self)].		
	
	"Detect non-deterministic behavior."
	wrappers add: (SdNonDeterministicBehaviorNotifier on: #next inClass: Random withTracer: self).

	^ wrappers reject: [:wrapper | wrapper isNil]
	! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mp 1/18/2010 16:59'!
currentId
	^ currentId! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mp 1/18/2010 16:59'!
currentId: anObject
	currentId := anObject! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/14/2011 15:15:19.508'!
currentNode

	^ currentNode! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/14/2011 15:15:26.189'!
currentNode: aNode

	currentNode := aNode.! !

!SdCallgraphTracer methodsFor: 'OBSOLETE' stamp: 'mt 7/15/2011 10:16:25.804'!
debugAt: aCallNode
	
	aCallNode callsBefore = 0
		ifTrue: [
			[BreakpointManager
				installInClass: aCallNode clientClass
				selector: aCallNode clientSelector.
				self callgraph run] ensure: [
					BreakpointManager unInstall: aCallNode clientClass >> aCallNode clientSelector]]
		ifFalse: [ | wrapper |
			wrapper := SdDebugWrapper 
				on: aCallNode clientSelector 
				inClass: aCallNode clientClass 
				waitingCalls: aCallNode callsBefore.
			self trace: {wrapper}].! !

!SdCallgraphTracer methodsFor: 'accessing - callgraph' stamp: 'mt 7/15/2011 12:57:47.822'!
getNode: anId

	^ self currentNode id = anId
		ifTrue: [self currentNode]
		ifFalse: [self callgraph at: anId]! !

!SdCallgraphTracer methodsFor: 'tracing - wrappers' stamp: 'mt 7/15/2011 09:57:54.603'!
installWrappers: someWrappers
	
	someWrappers do: [:each | each install].! !

!SdCallgraphTracer methodsFor: 'testing' stamp: 'mt 7/15/2011 13:05:34.34'!
isFirstRun

	^ isFirstRun! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'mt 7/16/2011 15:45:34.194'!
knownPropertiesAfterCall
	"Return all known properties that can be collected after a method call."
	
	^ #(
		returnClass "type of the returned object"
		returnObject "state copy of the returned object"
		returnId "serial identifier for the returned object in context of its type"
		receiverObjectAfter "state copy of the message receiving object AFTER the method call"
		receiverInstVarClassesAfter "types of the instance variables AFTER the method call"
		receiverInstVarIdsAfter "serial identifier for the instance variables AFTER the method call"
		argumentObjectsAfter "state copies of the message arguments AFTER the method class")! !

!SdCallgraphTracer methodsFor: 'properties' stamp: 'abc 8/18/2011 14:24:21.584'!
knownPropertiesBeforeCall
	"Return all known properties that can be collected before a method call."
	
	^ #(
		receiverId
		receiverObjectBefore "state copy of the message receiving object BEFORE the method call"
		receiverInstVarClassesBefore "types of the instance variables BEFORE the method call"
		receiverInstVarIdsBefore "serial identifier for the instance variables BEFORE the method call"
		argumentClasses "types of the message arguments"
		argumentObjectsBefore "state copies of the message arguments BEFORE the method class"
		argumentIds "serial identifier for the arguments in context of the argument class")! !

!SdCallgraphTracer methodsFor: 'tracing - callbacks' stamp: 'mt 7/15/2011 16:01:02.772'!
nextCallNodeOn: aClass with: aSelector receiverObject: theObject arguments: anArray callsBefore: aNumber
	
	| nextId node |
	nextId := self callgraph nextId: self currentId.

	node := isFirstRun
		"Callgraph is filled the first time."
		ifTrue: [self currentNode children add: (SdMethodCallNode new
			id: nextId;
			clientClass: aClass;
			clientSelector: aSelector;
			parent: self currentNode;
			receiverClass: theObject class;
			receiverId: (self objectIdFor: theObject);
			callsBefore: aNumber)]
		"Additional run adds information to all nodes."
		ifFalse: [self currentNode children
			detect: [:childNode | childNode id = nextId]
			ifNone: [SdNonDeterministicBehaviorDetected signal]].
	
	self
		currentNode: node;
		currentId: nextId.

	^ node id! !

!SdCallgraphTracer methodsFor: 'tracing - callbacks' stamp: 'mt 7/15/2011 16:22:33.5'!
objectIdFor: anObject
	"All objects that are given into this method will be held until tracing is over. This is needed to get the correct implementation of object id but also needs more memory."
	
	| instances |
	instances := self classDictionary at: anObject class name ifAbsentPut: [OrderedCollection new].
	^ instances
		identityIndexOf: anObject
		ifAbsent: [instances add: anObject. instances size]! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/14/2011 17:00:47.692'!
postProfilingCounts

	| bag |
	bag := Bag new.
	self callgraph do: [:node | bag add: node clientClass -> node clientSelector.
		node
			setProperty: #counts
			toValue: (bag occurrencesOf: node clientClass -> node clientSelector)].! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/14/2011 17:01:00.413'!
postProfilingMilliSeconds

	| duration |
	self callgraph do: [:node | 
		duration := node valueOfProperty: #duration.
		node setProperty: #duration toValue: duration asMilliSeconds].! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/14/2011 17:01:19.933'!
postProfilingPercentage

	| fullDuration duration |
	fullDuration := self callgraph children 
		inject: 0 into: [:sum :each | sum := sum + (each valueOfProperty: #durationPercent) asNanoSeconds].
					
	self callgraph do: [:node | 
		(node includesProperty: #durationPercent) 
			ifTrue: [duration := (node valueOfProperty: #durationPercent) asNanoSeconds.
				node setProperty: #durationPercent toValue: ((duration / fullDuration) * 100.0) rounded]].! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/15/2011 17:42:16.393'!
profile: aMode
	"Add profiling information to a callgraph. #duration, #durationPercent, #counts"
	
	(#(duration durationPercent counts) includes: aMode)
		ifFalse: [Error signal: 'Unsupported profiling mode.'].
	
	self tracingMode: aMode.
	self trace.! !

!SdCallgraphTracer methodsFor: 'profiling' stamp: 'mt 7/15/2011 16:48:17.002'!
profilingPostProcessing

	self tracingMode == #duration
		ifTrue: [self postProfilingMilliSeconds].
	self tracingMode == #durationPercent
		ifTrue: [self postProfilingPercentage].
	self tracingMode == #counts
		ifTrue: [self postProfilingCounts].! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'abc 8/18/2011 14:24:00.252'!
receiverId: dict

	(dict at: #node) receiverId:
		(self objectIdFor: (dict at: #receiver)).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/16/2011 16:15:02.244'!
receiverInstVarClassesAfter: dict

	(dict at: #node)
		setProperty: #receiverInstVarClassesAfter
		toValue: ((1 to: (dict at: #receiver) class instSize) collect: [:idx |
			((dict at: #receiver) instVarAt: idx) class]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/16/2011 16:15:06.091'!
receiverInstVarClassesBefore: dict

	(dict at: #node)
		setProperty: #receiverInstVarClassesBefore
		toValue: ((1 to: (dict at: #receiver) class instSize) collect: [:idx |
			((dict at: #receiver) instVarAt: idx) class]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/18/2011 14:12:08.394'!
receiverInstVarIdsAfter: dict

	((dict at: #node) includesProperty: #receiverInstVarClassesAfter)
		ifFalse: [self receiverInstVarClassesAfter: dict].

	(dict at: #node)
		setProperty: #receiverInstVarIdsAfter
		toValue: ((1 to: (dict at: #receiver) class instSize) collect: [:idx |
			self objectIdFor: ((dict at: #receiver) instVarAt: idx)]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/18/2011 14:13:04.98'!
receiverInstVarIdsBefore: dict

	((dict at: #node) includesProperty: #receiverInstVarClassesBefore)
		ifFalse: [self receiverInstVarClassesBefore: dict].

	(dict at: #node)
		setProperty: #receiverInstVarIdsBefore
		toValue: ((1 to: (dict at: #receiver) class instSize) collect: [:idx |
			self objectIdFor: ((dict at: #receiver) instVarAt: idx)]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/18/2011 14:11:32.634'!
receiverObjectAfter: dict

	((dict at: #node) includesProperty: #receiverInstVarClassesAfter)
		ifFalse: [self receiverInstVarClassesAfter: dict].

	(dict at: #node)
		setProperty: #receiverObjectAfter
		toValue: (dict at: #receiver) veryDeepCopy.! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/18/2011 14:12:38.448'!
receiverObjectBefore: dict

	((dict at: #node) includesProperty: #receiverInstVarClassesBefore)
		ifFalse: [self receiverInstVarClassesBefore: dict].

	(dict at: #node)
		setProperty: #receiverObjectBefore
		toValue: (dict at: #receiver) veryDeepCopy.! !

!SdCallgraphTracer methodsFor: 'tracing - running' stamp: 'mt 2/1/2012 12:03:57.46'!
reset
	"Reset the current position in the call tree and all local caches. This does not have to be called from the outside."

	self
		currentId: self callgraph rootId;
		currentNode: self callgraph;
		classDictionary: nil.! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/15/2011 15:08:02.855'!
returnClass: dict

	(dict at: #node)
		setProperty: #returnClass
		toValue: (dict at: #result) class.! !

!SdCallgraphTracer methodsFor: 'tracing - callbacks' stamp: 'mt 7/15/2011 12:57:39.085'!
returnFromNode: id
	
	self currentNode: (self currentNode id = id
		"Normal return."
		ifTrue: [self currentNode parent]
		"Wild jump through the stack!! =D"
		ifFalse: [(self callgraph findNodeInSubGraph: id startNode: self callgraph) parent]).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/18/2011 14:10:04.589'!
returnId: dict

	((dict at: #node) includesProperty: #returnClass)
		ifFalse: [self returnClass: dict].

	(dict at: #node)
		setProperty: #returnId
		toValue: (self objectIdFor: (dict at: #result)).! !

!SdCallgraphTracer methodsFor: 'properties - specific' stamp: 'mt 7/18/2011 14:09:57.727'!
returnObject: dict

	((dict at: #node) includesProperty: #returnClass)
		ifFalse: [self returnClass: dict].

	(dict at: #node)
		setProperty: #returnObject
		toValue: (dict at: #result) veryDeepCopy.! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'mt 7/15/2011 17:50:30.872'!
selectedClasses

	^ (self callgraph selectedCategories gather: [:cat |
		(SystemOrganization listAtCategoryNamed: cat)
			collect: [:className | Smalltalk at: className]])! !

!SdCallgraphTracer methodsFor: 'tracing' stamp: 'mt 2/1/2012 12:03:22.705'!
trace
	"Start a normal trace run with the current callgraph. Auto-select categories if not set."

	self callgraph selectedCategories ifEmpty: [
		self autoSelectCategories].

	(Smalltalk includesKey: #STestReference)
		ifTrue: [^ self traceOptimized].

	^ self trace: self createWrappers! !

!SdCallgraphTracer methodsFor: 'tracing - running' stamp: 'mt 7/15/2011 16:16:33.435'!
trace: someWrappers

	self reset.
	
	self installWrappers: someWrappers.

	"Set flag to optimize callgraph filling."
	isFirstRun := self callgraph isEmpty.

	[[
		| result |
		result := self callgraph run.
		self profilingPostProcessing.
		^ result
			] ensure: [self reset; uninstallWrappers: someWrappers]]
	
		on: SdNonDeterministicBehaviorDetected
		do: [:ex | self callgraph isNonDeterministic: true].
		
	^ nil! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 7/15/2011 17:54:10.38'!
traceEvent: aTraceItEvent
	"Create a new callgraph and re-use the selected categories."
	
	| selectedCategories |
	selectedCategories := self callgraph selectedCategories.
	
	self callgraph: (SdCallgraph new
		selectedCategories: selectedCategories;
		traceEvent: aTraceItEvent).
		
	^ self trace! !

!SdCallgraphTracer methodsFor: 'tracing - running' stamp: 'mt 2/1/2012 10:49:14.888'!
traceOptimized
	"Only call this method if you have Sight-Coverage installed."

	^ self trace: (self callgraph traceEvent itemKind == #test
		ifTrue: [self createWrappersOptimized]
		ifFalse: [self createWrappers])! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 7/14/2011 16:11:36.888'!
traceSourceCode: aSourceCodeString
	
	^ self
		traceSourceCode: aSourceCodeString
		receiver: nil! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 1/31/2012 18:26:18.137'!
traceSourceCode: aSourceCodeString receiver: anObject
	"Discards the current call graph and traces the given code."
	
	^ self traceEvent: (SdTraceItEvent
		expression: aSourceCodeString
		receiver: anObject)! !

!SdCallgraphTracer methodsFor: 'tracing - convenience' stamp: 'mt 1/31/2012 18:26:18.129'!
traceTest: aTestCaseClass method: aMethodSelector

	^ self traceEvent: (SdTraceItEvent testClass: aTestCaseClass selector: aMethodSelector)! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'mt 7/15/2011 16:48:51.715'!
tracingMode
	"#normal, #duration, #durationPercent, #counts, #property"

	^ tracingMode ifNil: [tracingMode := #normal]! !

!SdCallgraphTracer methodsFor: 'accessing' stamp: 'mt 7/15/2011 16:43:38.796'!
tracingMode: anObject
	tracingMode := anObject! !

!SdCallgraphTracer methodsFor: 'tracing - wrappers' stamp: 'mt 7/15/2011 09:58:01.239'!
uninstallWrappers: someWrappers
	
	someWrappers do: [:each | each uninstall].! !

!SdCallgraphTracer methodsFor: 'tracing - wrappers' stamp: 'mt 7/15/2011 16:50:37.681'!
wrapperClass

	"Profile method calls, e.g., measure duration in milliseconds."
	(#(duration durationPercent counts) includes: self tracingMode)
		ifTrue: [^ SdProfilingWrapper].
		
	"Fetch additional properties for all nodes."
	self tracingMode == #property
		ifTrue: [^ SdGlobalPropertyWrapper].

	"Just basic callgraph."
	^ SdCallWrapper! !

Object subclass: #SdTestPerson
	instanceVariableNames: 'firstname lastname sibling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph-Testbed'!

SdTestPerson subclass: #SdTestCustomer
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph-Testbed'!

!SdTestCustomer methodsFor: 'accessing' stamp: 'TM 5/17/2011 10:13:16.833'!
address

	^ address! !

!SdTestCustomer methodsFor: 'accessing' stamp: 'TM 5/17/2011 10:11:41.832'!
address: aString

	address := aString! !

!SdTestPerson methodsFor: 'accessing' stamp: 'TM 4/26/2011 15:54:25.021'!
firstname
	"Answer the value of firstname"

	^ firstname! !

!SdTestPerson methodsFor: 'accessing' stamp: 'TM 6/21/2011 16:06:36.25'!
firstname: anObject
	"Set the value of firstname"

	firstname := anObject! !

!SdTestPerson methodsFor: 'initialization' stamp: 'tfel 5/10/2011 17:25:17.408'!
initialize

	super initialize.
	firstname := 'Fritz'.
	lastname := 'Foo'.! !

!SdTestPerson methodsFor: 'signals' stamp: 'mt 7/16/2011 12:38:21.695'!
lastNameChanged: newLastName

	self emit.! !

!SdTestPerson methodsFor: 'accessing' stamp: 'TM 4/26/2011 15:54:25.04'!
lastname
	"Answer the value of lastname"

	^ lastname! !

!SdTestPerson methodsFor: 'accessing' stamp: 'mt 7/16/2011 12:38:57.927'!
lastname: aString

	aString = lastname ifTrue: [^ self].
	lastname := aString.
	self lastNameChanged: lastname.! !

!SdTestPerson methodsFor: 'printing' stamp: 'mt 7/16/2011 12:35:26.186'!
nameAsScienceFictionHero
	"Convert the firstname into a super cool SF hero name."

	^ self firstname, 'ainous'! !

!SdTestPerson methodsFor: 'accessing' stamp: 'mt 7/16/2011 12:33:57.305'!
sibling

	^ sibling! !

!SdTestPerson methodsFor: 'accessing' stamp: 'mt 7/16/2011 12:33:49.872'!
sibling: aPerson

	sibling := aPerson.! !

TestCase subclass: #SdCallgraphTests
	instanceVariableNames: 'tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph-Tests'!

!SdCallgraphTests methodsFor: 'running' stamp: 'mt 7/16/2011 12:57:47.417'!
callGraphFor: aSelector

	tracer callgraph selectedCategories: {SdPersonTests category}.
	tracer traceTest: SdPersonTests method: aSelector.
	^ tracer callgraph! !

!SdCallgraphTests methodsFor: 'running' stamp: 'mt 7/16/2011 12:57:50.744'!
setUp

	super setUp.

	tracer := SdCallgraphTracer new.! !

!SdCallgraphTests methodsFor: 'tests' stamp: 'mt 7/18/2011 14:07:25.668'!
test01SpecificIdCollectionError

	| graph node |
	graph := self callGraphFor: #test05MultiContext.
	node := graph at: 1.

	#(receiverId resultId argumentIds receiverInstVarIdsBefore receiverInstVarIdsAfter)
		do: [:property |	self
			should: [tracer collectProperty: property inNode: node] raise: Error;
			should: [node requestProperty: property] raise: Error].! !

!SdCallgraphTests methodsFor: 'sprint3' stamp: 'mt 7/16/2011 13:26:44.515'!
testDeepCopyOfFrame

	| objectBefore objectAfter graph |
	graph := self callGraphFor: #test02ChangingPerson.
	tracer collectProperties: #(receiverObjectBefore receiverObjectAfter) inNode: (graph at: 5).
	
	"before -> Fritz, after -> Frank"
	objectBefore := (graph at: 5) valueOfProperty: #receiverObjectBefore.
	objectAfter := (graph at: 5) valueOfProperty: #receiverObjectAfter.
	
	self assert: objectBefore class = SdTestPerson.
	self assert: objectBefore firstname = 'Fritz'.
	self assert: objectAfter class = SdTestPerson.
	self assert: objectAfter firstname = 'Frank'.! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 14:29:37.036'!
testFindClassOfCall

	| graph |
	graph := self callGraphFor: #test01InitialFirstname.
	self assert: (graph at: 5) clientClass = SdTestPerson.! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 18:33:42.531'!
testFindInitialization

	| initNode selectedNode graph |
	graph := self callGraphFor: #test06MultiplePersons.
	tracer collectShallowReturn.
	
	selectedNode := graph at: 15.
	initNode := graph detect: [:n | n isInstantiationOf: selectedNode].
	self assert: initNode id = 10.
	self assert: initNode clientSelector = #basicNew.

! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 15:01:30.781'!
testFindObjectIdOfCall

	| graph |
	graph := self callGraphFor: #test01InitialFirstname.
	self assert: (graph at: 5) receiverId isNumber.! !

!SdCallgraphTests methodsFor: 'sprint2' stamp: 'mt 7/16/2011 16:46:55.571'!
testFindObjectInContext

	| graph nodes selectedNode |
	graph := self callGraphFor: #test07Siblings.
	tracer collectShallowContext.
	
	selectedNode := graph at: 5. "Tim"
	nodes := graph select: [:n | n isInContextWith: selectedNode].
	self assert: nodes size = (2 "basicNew (retVal), initialize (self)" +
								  1 "firstname: (self)" +
								  1 "sibling: (argument)" +
								  1 "firstname (instVar)").
	#(basicNew initialize firstname: sibling: firstname) withIndexDo: [:s :idx |
		self assert: (nodes at: idx) clientSelector = s].
! !

!SdCallgraphTests methodsFor: 'sprint4' stamp: 'mt 7/16/2011 16:46:55.64'!
testFindObjectInContextMultipleTimes

	| graph timNode1 timNode2 struppiArgTimNode |
	graph := self callGraphFor: #test05MultiContext.
	tracer collectShallowContext.
	
	timNode1 := graph find: #firstname: callOn: SdTestPerson number: 1. "tim firstname: 'Tim'."
	timNode2 := graph find: #firstname callOn: SdTestPerson number: 1. "tim firstname."

	struppiArgTimNode := graph find: #sibling: callOn: SdTestPerson number: 2. "struppi sibling: tim."
	self assert: (struppiArgTimNode isInContextWith: timNode1).
	self assert: (struppiArgTimNode isInContextWith: timNode2).
	self assert: (struppiArgTimNode globalArgumentIds first) = timNode1 globalReceiverId.
	self assert: (struppiArgTimNode globalArgumentIds first) = timNode2 globalReceiverId.! !

!SdCallgraphTests methodsFor: 'sprint4' stamp: 'mt 7/16/2011 16:46:55.711'!
testFindObjectInContextWithoutDestroyingReceiverId

	| graph nodes selectedNode oldRecvId |
	graph := self callGraphFor: #test07Siblings.
	tracer collectShallowContext.
	
	selectedNode := graph at: 6.
	oldRecvId := selectedNode receiverId.
	nodes := graph select: [:n | n isInContextWith: selectedNode].
	self assert: (graph at: 6) receiverId = oldRecvId.! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 16:38:00.585'!
testFindOrderOfObject

	| graph |
	graph := self callGraphFor: #test06MultiplePersons.
	self assert: (graph at: 13) receiverId = 3.! !

!SdCallgraphTests methodsFor: 'sprint2' stamp: 'mt 7/16/2011 13:19:45.905'!
testFindReadsOfObject

	| graph nodes selectedNode |
	graph := self callGraphFor: #test06MultiplePersons.
	selectedNode := graph at: 13. "Tim"
	nodes := graph select: [:n | n isReadOf: selectedNode].
	self assert: nodes size = 2.
	self assert: nodes first clientSelector = #firstname.
	self assert: nodes second clientSelector = #firstname.

! !

!SdCallgraphTests methodsFor: 'sprint2' stamp: 'mt 7/16/2011 13:19:50.257'!
testFindSendsToObject

	| graph nodes selectedNode |
	graph := self callGraphFor: #test06MultiplePersons.
	selectedNode := graph at: 13. "Tim"
	nodes := graph select: [:n | n isSameObjectAs: selectedNode].
	self assert: nodes size = 5.
	#(initialize firstname: firstname #nameAsScienceFictionHero firstname)
		withIndexDo: [:selector :index |
			self assert: (nodes at: index) clientSelector = selector].
! !

!SdCallgraphTests methodsFor: 'sprint2' stamp: 'mt 7/16/2011 13:19:58.606'!
testFindWritesToObject

	| graph nodes selectedNode |
	graph := self callGraphFor: #test06MultiplePersons.
	selectedNode := graph at: 13. "Tim"
	nodes := graph select: [:n | n isWriteTo: selectedNode].
	self assert: nodes size = 2.
	self assert: nodes first clientSelector = #initialize.
	self assert: nodes second clientSelector = #firstname:.
! !

!SdCallgraphTests methodsFor: 'sprint4' stamp: 'mt 7/16/2011 16:42:00.756'!
testFindingObjects
	| graph node1 node2 node3 node4 |
	graph := self callGraphFor: #test04MultiCalls.
	node1 := graph at: 5. "tim firstname: 'Tim'."
	node2 := graph at: 6. "tim firstname."
	node3 := graph at: 7. "tim firstname."
	"graph at: 9. Person basicNew"
	"graph at: 10. struppi initialize"
	node4 := graph at: 10. "struppi firstname."

	self assert: node1 = (graph find: #firstname: callOn: SdTestPerson number: 1).
	self assert: node2 = (graph find: #firstname callOn: SdTestPerson number: 1).
	self assert: (graph findAll: #firstname callsOn: SdTestPerson number: 1) size = 2.
	self assert: ((graph findAll: #firstname callsOn: SdTestPerson number: 1) includes: node3).
	self assert: ((graph findAll: #firstname callsOn: SdTestPerson number: 1) includes: node2).
	self assert: ((graph findAll: #firstname callsOn: SdTestPerson number: 2) size = 1).
	self assert: ((graph findAll: #firstname callsOn: SdTestPerson number: 2) includes: node4).
	self assert: node4 = (graph find: #firstname callOn: SdTestPerson number: 2).! !

!SdCallgraphTests methodsFor: 'sprint4' stamp: 'mt 7/16/2011 16:44:10.653'!
testInstanceCountDoesNotChangeOnRetrace
	
	| graph node previousReceiverId |
	graph := self callGraphFor: #test05MultiContext.

	node := graph find: #firstname: callOn: SdTestPerson number: 1. "tim firstname: 'Tim'."
	previousReceiverId := node receiverId.

	tracer trace. "again"

	self assert: node receiverId = previousReceiverId.
	self assert: (graph find: #firstname: callOn: SdTestPerson number: 1) receiverId = previousReceiverId.! !

!SdCallgraphTests methodsFor: 'sprint1' stamp: 'mt 7/16/2011 16:45:06.714'!
testMultipleInstances

	|instances klass graph |
	graph := self callGraphFor: #test06MultiplePersons.  
	klass := (graph at: 5) receiverClass.
	instances := graph select: [:node | node isInstantiationOf: klass].
	self assert: instances size = 3.
	instances do: [ :item | self assert: item receiverClass theNonMetaClass = SdTestPerson].

! !

TestCase subclass: #SdPersonTests
	instanceVariableNames: 'person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Callgraph-Testbed'!

!SdPersonTests commentStamp: 'mt 7/16/2011 13:21:22.282' prior: 0!
The behavior of these tests influence SdCallgraphTests as the resulting call graphs are tested.!

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:40:28.773'!
test01InitialFirstname

	self assert: SdTestPerson new firstname notNil.
	! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:41:20.09'!
test02ChangingPerson

	| person |
	person := SdTestPerson new.
	person firstname: 'Frank'.
	person firstname: 'Not Frank'.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:41:41.033'!
test03FamilyName

	| frank fritz |
	
	frank := SdTestPerson new firstname: 'Frank'.
	fritz := SdTestPerson new.

	fritz connect: frank signal: #lastNameChanged: toSelector: #lastname:.

	self
		assert: 'Foo' equals: frank lastname;
		assert: 'Foo' equals: fritz lastname.
	
	frank lastname: 'Bar'.
	  
	self
		assert: 'Bar' equals: frank lastname;
		assert: 'Bar' equals: fritz lastname.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:42:09.37'!
test04MultiCalls

	| tim struppi |
	tim := SdTestPerson new.
	tim firstname: 'Tim'.
	tim firstname.
	tim firstname.
	struppi := SdTestPerson new.
	struppi firstname.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:42:41.665'!
test05MultiContext

	| tim struppi |
	tim := SdTestPerson new.
	tim firstname: 'Tim'.
	tim firstname.
	struppi := SdTestPerson new.
	struppi firstname: 'Struppi'.
	struppi sibling: tim.
	self assert: 'Struppi' equals: struppi firstname.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 14:29:58.317'!
test06MultiplePersons

	| default frank tim customer |

	default := SdTestPerson new.
	self assert: default firstname = 'Fritz'.

	frank := SdTestPerson new.
	frank firstname: 'Frank'.
	self assert: frank firstname = 'Frank'.
	
	tim := SdTestPerson new.
	tim firstname: 'Tim'.
	self assert: tim firstname = 'Tim'.
	tim nameAsScienceFictionHero.
	self assert: frank nameAsScienceFictionHero = 'Frankainous'.
	
	customer := SdTestCustomer new.
	customer firstname: 'John'.! !

!SdPersonTests methodsFor: 'tests' stamp: 'mt 7/16/2011 12:43:20.899'!
test07Siblings

	| tim struppi |
	tim := SdTestPerson new.
	tim firstname: 'Tim'.
	struppi := SdTestPerson new.
	struppi firstname: 'Struppi'.
	struppi sibling: tim.
	self assert: struppi firstname = 'Struppi'.! !

!SystemChangeNotifier methodsFor: '*sight-callgraph' stamp: 'mt 5/5/2011 10:36:11.629'!
traceSourceCode: string

	^ self traceSourceCode: string context: nil    ! !

!SystemChangeNotifier methodsFor: '*sight-callgraph' stamp: 'mt 1/31/2012 18:26:18.157'!
traceSourceCode: string context: context

	self trigger: (SdTraceItEvent
		expression: string
		context: context).! !

!SystemChangeNotifier methodsFor: '*sight-callgraph' stamp: 'mt 1/31/2012 18:26:18.154'!
traceTestClass: aTestCaseClass selector: aSymbol

	self trigger: (SdTraceItEvent
		testClass: aTestCaseClass
		selector: aSymbol).! !
